# Generated by sila2.code_generator; sila2.__version__: 0.12.2
from __future__ import annotations

from abc import ABC, abstractmethod
from queue import Queue
from typing import TYPE_CHECKING, List, Optional, Union

from sila2.server import FeatureImplementationBase, MetadataDict

from .measurementcontroller_types import (
    UUID,
    LoadFeatureCallConfigurationDB_Responses,
    SetFeatureCallConfiguration_Responses,
    SetPollingInterval_Responses,
    StartMeasurement_Responses,
    StopMeasurement_Responses,
)

if TYPE_CHECKING:
    from ...server import Server


class MeasurementControllerBase(FeatureImplementationBase, ABC):
    parent_server: Server

    _CurrentMeasurements_producer_queue: Queue[Union[List[UUID], Exception]]
    _CurrentMeasurements_current_value: List[UUID]

    _PollingInterval_producer_queue: Queue[Union[float, Exception]]
    _PollingInterval_current_value: float

    def __init__(self, parent_server: Server):
        """

        Allows to start and stop a measurement.

        """
        super().__init__(parent_server=parent_server)

        self._CurrentMeasurements_producer_queue = Queue()

        self._PollingInterval_producer_queue = Queue()

    @abstractmethod
    def get_FeatureCallConfiguration(self, *, metadata: MetadataDict) -> str:
        """
        Get current Feature Call Configuration (YAML string).

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Get current Feature Call Configuration (YAML string).
        """

    def update_CurrentMeasurements(
        self, CurrentMeasurements: List[UUID], queue: Optional[Queue[List[UUID]]] = None
    ) -> None:
        """
        A List of Measurement Command Execution UUIDs that are currently running.

        This method updates the observable property 'CurrentMeasurements'.

        :param queue: The queue to send updates to. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._CurrentMeasurements_producer_queue
            self._CurrentMeasurements_current_value = CurrentMeasurements
        queue.put(CurrentMeasurements)

    def CurrentMeasurements_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[List[UUID]]]:
        """
        A List of Measurement Command Execution UUIDs that are currently running.

        This method is called when a client subscribes to the observable property 'CurrentMeasurements'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """

    def abort_CurrentMeasurements_subscriptions(
        self, error: Exception, queue: Optional[Queue[List[UUID]]] = None
    ) -> None:
        """
        A List of Measurement Command Execution UUIDs that are currently running.

        This method aborts subscriptions to the observable property 'CurrentMeasurements'.

        :param error: The Exception to be sent to the subscribing client.
            If it is no DefinedExecutionError or UndefinedExecutionError, it will be wrapped in an UndefinedExecutionError.
        :param queue: The queue to abort. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._CurrentMeasurements_producer_queue
        queue.put(error)

    @property
    def current_CurrentMeasurements(self) -> List[UUID]:
        try:
            return self._CurrentMeasurements_current_value
        except AttributeError:
            raise AttributeError("Observable property CurrentMeasurements has never been set")

    def update_PollingInterval(self, PollingInterval: float, queue: Optional[Queue[float]] = None) -> None:
        """
        The polling interval for the Measurement Controller in seconds.

        This method updates the observable property 'PollingInterval'.

        :param queue: The queue to send updates to. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._PollingInterval_producer_queue
            self._PollingInterval_current_value = PollingInterval
        queue.put(PollingInterval)

    def PollingInterval_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[float]]:
        """
        The polling interval for the Measurement Controller in seconds.

        This method is called when a client subscribes to the observable property 'PollingInterval'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """

    def abort_PollingInterval_subscriptions(self, error: Exception, queue: Optional[Queue[float]] = None) -> None:
        """
        The polling interval for the Measurement Controller in seconds.

        This method aborts subscriptions to the observable property 'PollingInterval'.

        :param error: The Exception to be sent to the subscribing client.
            If it is no DefinedExecutionError or UndefinedExecutionError, it will be wrapped in an UndefinedExecutionError.
        :param queue: The queue to abort. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._PollingInterval_producer_queue
        queue.put(error)

    @property
    def current_PollingInterval(self) -> float:
        try:
            return self._PollingInterval_current_value
        except AttributeError:
            raise AttributeError("Observable property PollingInterval has never been set")

    @abstractmethod
    def StartMeasurement(self, Name: str, *, metadata: MetadataDict) -> StartMeasurement_Responses:
        """

        Starting an experiment



         :param Name: Name of the Measurement, can be used as an identifier for this measurement.

         :param metadata: The SiLA Client Metadata attached to the call

         :return:

             - CommandExecutionUUID: The Command Execution UUID according to the SiLA Standard.


        """

    @abstractmethod
    def StopMeasurement(self, CommandExecutionUUID: UUID, *, metadata: MetadataDict) -> StopMeasurement_Responses:
        """
        Stop the current Measurement


        :param CommandExecutionUUID: The Command Execution UUID according to the SiLA Standard.

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def SetPollingInterval(self, Interval: float, *, metadata: MetadataDict) -> SetPollingInterval_Responses:
        """
        Set the polling interval for the Measurement Controller in seconds.


        :param Interval: Polling interval in seconds (Real).

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def LoadFeatureCallConfigurationDB(
        self, LARADatabaseConnector: str, Namespace: str, FeatureCallConfigurationName: str, *, metadata: MetadataDict
    ) -> LoadFeatureCallConfigurationDB_Responses:
        """
        Load a Feature Call Configuration that describes what SiLA servers to call with which commads from the LARA Database in YAML format as defined in the sila_feature_call_model.yaml LinkML data model.


        :param LARADatabaseConnector: Connector to the LARA Database

        :param Namespace: Namespace of the Feature Call Configuration (YAML) to be loaded from the (LARA) database

        :param FeatureCallConfigurationName: Name of the Feature Call Configuration (YAML) to be loaded from the (LARA) database

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def SetFeatureCallConfiguration(
        self, FeatureCallConfiguration: str, *, metadata: MetadataDict
    ) -> SetFeatureCallConfiguration_Responses:
        """
        Set a new Feature Call Configuration that describes what SiLA servers to call with which commads. The configuration should be provided as a string in YAML format as defined in the sila_feature_call_model.yaml LinkML data model.


        :param FeatureCallConfiguration: New Feature Call Configuration to be set - (YAML string).

        :param metadata: The SiLA Client Metadata attached to the call

        """
